<template>

<div :class="{expanded:expanded}" class="d-flex flex-column featurelist_panel">
  <b-row  class="justify-content-md-center m-2 featurelist_panel_header">
    <b-col cols="4"></b-col>
    <b-col cols="4" class="text-center">
      <h4 class="text-center mt-1" :title="title" v-b-tooltip>{{title}}</h4>
    </b-col>
    <b-col cols="3" class="text-center">
      <b-button size="sm" class="header_button"  style="margin-right:6px;"
        v-if="expanded==true"
        v-b-tooltip.hover title="Activer la selection multiple" :pressed.sync="multipleSelection">
        <b-icon icon="check-all" variant="light"></b-icon> &nbsp;
      </b-button>
      <b-button size="sm" class="header_button"  style="margin-right:6px;"
      v-b-tooltip
      title="Afficher le panneau  pour filtrer les résultats"
      v-if="expanded==true" :pressed.sync="showFilterPanel">
        <span class="btn_text">Filtrer</span>
      <b-icon v-if="hasActiveFilter()==false" icon="funnel" variant="light"></b-icon>
      <b-icon v-if="hasActiveFilter()==true" icon="funnel-fill" variant="light"></b-icon> &nbsp;
      </b-button>
      <button class="btn btn-sm p-0"  style="margin-right:6px;" v-if="expanded==false"
        v-b-tooltip.hover title="Agrandir" @click="expand()">
        <b-icon icon="arrows-angle-expand" variant="light"></b-icon> &nbsp;
      </button>
      <b-dropdown size="sm" toggle-class="header_button" no-caret  v-if="expanded==true">
        <template #button-content>
          <span class="btn_text">Exporter</span>
          <b-icon icon="cloud-download" variant="light"></b-icon> &nbsp;
        </template>
        <b-dropdown-item @click="download('csv','csv')" href="#"><b-icon icon="arrow-right"/>&nbsp;CSV</b-dropdown-item>
        <b-dropdown-item @click="download('json','json')" href="#"><b-icon icon="arrow-right"/>&nbsp;Geojson</b-dropdown-item>
        <b-dropdown-item @click="download('kml','kml')" href="#"><b-icon icon="arrow-right"/>&nbsp;Kml</b-dropdown-item>
        <b-dropdown-item @click="download('shape-zip','zip')" href="#"><b-icon icon="arrow-right"/>&nbsp;shapefile</b-dropdown-item>
      </b-dropdown>

    <!--
      <button class="btn btn-sm p-0"  style="margin-right:6px;" v-if="expanded==true"
        v-b-tooltip.hover title="Télécharger" @click="download()">
        <b-icon icon="cloud-download" variant="light"></b-icon> &nbsp;
      </button>
      -->
    </b-col>
    <b-col cols="1" class="text-right">
      <b-icon class="close-btn" icon="x-square" variant="light" @click="close()"></b-icon>
    </b-col>
  </b-row>
  <div class="featurelist_panel_body">
    <b-col cols="12" class="h-100 d-flex flex-column">
      <div v-if="loading==true" class="center loading_panel mx-auto">
        <b-spinner variant="info" type="grow" label="Loading" style="margin-left:25px;"></b-spinner>
        <b-spinner variant="info" type="grow" label="Loading" style="margin-left:5px;"></b-spinner>
        <b-spinner variant="info" type="grow" label="Loading" style="margin-left:5px;"></b-spinner>
        <span style="margin-left:5px;">Chargement en cours<br/></span>
      </div>
      <div  v-if="loading==false && showFilterPanel" class="flex-row filter_panel" style="flex: 1 1 100px;">
        <FormTextInput v-if="showFilterPanel && !showAddFilterPanel" md="4"
          v-bind:label="'Filtres Attributaires'" v-model="layer.tableFilter" :cols="8" :labelcols="2"
          v-bind:placeholder="'Aucun filtre attributaire'">
          <b-col cols="1">
            <button class="btn btn-sm p-0"  style="margin-right:6px;"
                  v-if="layer.tableFilter!=undefined && layer.tableFilter.length > 0"
                  @click="removeFilters()" v-b-tooltip.hover
                  title="Supprimer les filtres">
                    <b-icon icon="trash" variant="danger"></b-icon> &nbsp;
            </button>
          </b-col>
          <b-col cols="6" align-self="end" md="2">
            <b-dropdown size="sm"
              text="Ajouter un Filtre...."
              toggle-class="bg_color-second-outlined btn-secondary dd_btn"
              class="m-md-2 bg_color-second-outlined btn-secondary dd_btn">
              <template #button-content>
               <b-icon icon="plus"/>&nbsp;Ajouter un Filtre
              </template>
              <b-dd-text class="filter_header">&nbsp;Ajouter un Filtre</b-dd-text>
              <b-dropdown-item class="filter_type"
                @click="showAddFilterPanel=!showAddFilterPanel">
                <b-icon icon="spellcheck" variant="primary"></b-icon>
                &nbsp;Attributaire</b-dropdown-item>
              <b-dropdown-item @click="addPolygoneFilter()" class="filter_type"
                title="Ajouter un filtre spatiale de type Polygone">
                <b-icon icon="bounding-box" variant="primary"/>
                &nbsp;Spatial (Polygone)</b-dropdown-item>
              <b-dropdown-item @click="addPointFilter()" class="filter_type"
                title="Ajouter un filtre spatiale de type Point">
                <b-icon icon="geo" variant="primary"/>
                &nbsp;Spatial (Point)</b-dropdown-item>
            </b-dropdown>
          </b-col>
          <b-col cols="6" md="1">
          </b-col>
        </FormTextInput>
        <b-row align-v="center" class="mb-1" v-if="showFilterPanel && !showAddFilterPanel">
          <b-col cols="2">
              Filtre Spatial
          </b-col>
          <b-col cols="5">
            <span v-if="layer.tableGeometricFilter==undefined
              ||layer.tableGeometricFilter==''">Aucun filtre spatial</span>
            <span v-else><b-icon icon="check2-square" variant="success"></b-icon> Filtre spatial actif
              <button class="btn btn-sm p-0"  style="margin-right:6px;"
              @click="removeSpatialFilter()" v-b-tooltip.hover
              title="Supprimer le filtre spatial">
                <b-icon icon="trash" variant="danger"></b-icon> &nbsp;
            </button></span>
          </b-col>
        </b-row>
        <b-row align-v="center" class="mb-3" v-if="showFilterPanel && !showAddFilterPanel">
           <b-button class="bg_color-second-outlined btn-secondary mx-auto" size="sm"
              @click="applyFilters()"
              title="Appliquer les filtres">Appliquer&nbsp;
            </b-button>
        </b-row>
        <AddFilterPanel :layer="layer" v-if="showAddFilterPanel"
          @add_filter="addTableFilter($event)"
          @cancel="showAddFilterPanel=false"/>
      </div>
      <div v-if="loading==false && showFilterPanel == false" style="overflow:auto;flex: 1 1 100px;">
         <FeatureListTable :layer="layer" v-if="showFilterPanel == false"
          :features="features"
          :attributes="attributes"
          :selectedFeatures="selectedFeatures" @onClick="onClick($event)" @changeSort="onSortChange($event)" />
      </div>
      <b-row v-if="loading==false && showFilterPanel == false">
        <b-col class="map-paging-infos">
          {{pagingInfos}}
        </b-col>
         <b-col>
           <b-pagination size="sm" v-if="rows>perPage" class="m-auto"
          v-model="currentPage" :total-rows="rows" :per-page="perPage" first-number
            last-number
          @change="pageChange($event)"
          align="center"  style="width=100%">
        </b-pagination>
        </b-col>
         <b-col class="map-paging-infos">
          <span v-if="rows>perPage" >Tableau: {{perPage}} résultats par page</span>
        </b-col>
      </b-row>
    </b-col>
  </div>
</div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
/* eslint-disable @typescript-eslint/no-this-alias */
/* eslint-disable prefer-destructuring */
import Component from 'vue-class-component';
import BaseComponent from '@/components/BaseComponent';
import Modify from 'ol/interaction/Modify';
import LayerConfig from '@/models/map-context/LayerConfig';
import { Feature } from 'ol';
import { WFS, MVT, GeoJSON } from 'ol/format';
import axios, { AxiosResponse } from 'axios';
import {
  LineString,
  MultiLineString,
  MultiPoint,
  MultiPolygon,
  LinearRing,
  Point,
  Polygon,
  Geometry,
} from 'ol/geom';
import {
  Circle, Fill, Stroke, Style,
} from 'ol/style';
import VectorSource from 'ol/source/Vector';
import VectorLayer from 'ol/layer/Vector';
import { Draw } from 'ol/interaction';
import CircleStyle from 'ol/style/Circle';
import WKT from 'ol/format/WKT';
import { EventBus, EVENTS } from '@/services/EventBus';
import FileSaver from 'file-saver';
import Select from 'ol/interaction/Select';
import { addProjection, Projection, addCoordinateTransforms } from 'ol/proj';
import Filter from '@/models/map-context/filter/Filter';
import AlertMessage from '@/models/shared/AlertMessage';
import { Type } from 'ol/geom/Geometry';
import FormTextInput from '../shared/FormTextInput.vue';
import AddFilterPanel from './AddFilterPanel.vue';
import FeatureListTable from './FeatureListTable.vue';

@Component({
  props: {
    layer: LayerConfig,
    expanded: Boolean,
  },
  components: {
    AddFilterPanel,
    FormTextInput,
    FeatureListTable,
  },
})
export default class FeatureListPanel extends BaseComponent {
  layer!: LayerConfig;

  title = 'Liste des objets';

  attributes:any=[];

  currentPage = 1;

  perPage = 20;

  multipleSelection = false;

  maxFeatureLoaded = false;

  rows = 0;

  nbFeatureServerSide = -1;

  features:any=[];

  allFeatures:any=[];

  featureSource!:VectorSource<any>;

  olLayer!:any;

  loading = false;

  expanded!:boolean;

  showAddFilterPanel = false;

  showFilterPanel = false;

  selectedFeatures:any=[];

  select!:Select;

  modify:any;

  pagingInfos = '';

  selectForUpdate:any;

  defaultStyle = new Style({
    fill: new Fill({
      color: 'rgba(253,255,255,0.3)',
    }),
    stroke: new Stroke({
      color: '#FF0000',
      width: 2,
    }),
    image: new Circle({
      radius: 5,
      stroke: new Stroke({
        color: '#FF0000',
        lineDash: [],
        width: 2,
      }),
      fill: new Fill({
        color: 'rgba(253,255,255,0.3)',
      }),
    }),
  });

  selectStyle = new Style({
    fill: new Fill({
      color: 'rgba(253,255,154,0.2)',
    }),
    stroke: new Stroke({
      color: 'rgba(253,255,154,0.7)',
      width: 2,
    }),
    image: new Circle({
      radius: 7,
      stroke: new Stroke({
        color: 'rgba(253,255,154,0.7)',
        lineDash: [],
        width: 2,
      }),
      fill: new Fill({
        color: 'rgba(253,255,154,0.2)',
      }),
    }),
  });

  geomFilterSource:any;

  vector:any;

  draw:any;

  sortParameters:any;

  currentUrl = '';

  dismissCountDown = 0;

  mounted():void{
    this.refresh();
    EventBus.$emit(EVENTS.DISABLE_SELECTION);
    EventBus.$emit(EVENTS.OPEN_LEFT_SIDE_MENU, '');
    addProjection(new Projection({
      code: 'WGS84',
      units: 'degrees',
    }));

    addCoordinateTransforms(
      'WGS84',
      'EPSG:4326',
      (coordinate) => [coordinate[1], coordinate[0]],
      (coordinate) => [coordinate[1], coordinate[0]],
    );
  }

  removeFilters() {
    this.layer.tableFilter = '';
    this.refresh();
  }

  removeSpatialFilter() {
    this.layer.tableGeometricFilter = '';
    if (this.geomFilterSource) {
      this.geomFilterSource.clear();
    }

    this.refresh();
  }

  countDownChanged(dismissCountDown:any) {
    this.dismissCountDown = dismissCountDown;
  }

  refreshFromWFS() {
    console.log('refresh');
    this.rows = this.layer.getLayerSource().getFeatures().length;
    this.allFeatures = this.layer.getLayerSource().getFeatures();
    if (this.allFeatures.length > this.perPage) {
      this.features = this.allFeatures.slice(0, this.perPage);
    } else {
      this.features = this.allFeatures;
    }
    this.refreshInfos();
  }

  refresh() {
    this.showFilterPanel = false;
    this.rows = 0;
    this.attributes = this.layer.layerProperties
      .filter((x) => x.name !== this.layer.getGeomAttributeName()).slice(0, 5);
    if (this.expanded) {
      this.attributes = this.layer.layerProperties
        .filter((x) => x.name !== this.layer.getGeomAttributeName());
      this.perPage = 1000;
    }

    if (this.layer.isWFS()) {
      this.layer.getLayerSource().clear();
      this.layer.getLayerSource().once('featuresloadend', this.refreshFromWFS);
      this.layer.getLayerSource().refresh();
    } else if (this.layer.isWMS() && this.layer.hasWFSCapacity()) {
      const urlGetFeature = this.layer.wmsUrlToWfs(this.layer.getFeatureWFSUrl());
      const maxFeatures = this.layer.maxFeatures;
      let url = `${urlGetFeature
      }&maxfeatures=${maxFeatures
      }&count=${maxFeatures
      }&typenames=${this.layer.layername}`
        + `&typename=${this.layer.layername}&`
        + 'outputFormat=json&srsname=EPSG:3857';
      if (this.hasActiveFilter()) {
        url += `&CQL_FILTER=${encodeURIComponent(this.layer.getTableFilterValue())}`;
      }
      this.addVectorLayer();
      this.loading = true;
      this.currentUrl = url;
      axios.get(url).then((reponse) => {
        this.loading = false;
        this.allFeatures = new GeoJSON().readFeatures(reponse.data);
        if (reponse.data.numberMatched) {
          this.nbFeatureServerSide = reponse.data.numberMatched;
        }
        console.log(reponse.data);
        this.featureSource.addFeatures(this.allFeatures);
        this.rows = this.allFeatures.length;
        this.features = this.allFeatures.slice(0, this.perPage);
        this.getOpenLayersMapService().map.updateSize();
        this.refreshInfos();

        // this.getMapService().zoomToExtent(this.featureSource.getExtent());
        // voir s'il faut zoomer sur le resultat
      }, (error) => {
        this.loading = false;
        console.log(error);
        EventBus.$emit(EVENTS.ERROR, 'Problème de chargement des objets. Vérifiez que vous avez les droits de téléchargement sur cette couche');
      });
    } else {
      this.addVectorLayer();
      const extent = this.getMapService().getMapExtent();
      if (this.layer.getLayerSource().getFeatures) {
        this.allFeatures = this.layer.getLayerSource().getFeatures();
      } else {
        this.allFeatures = this.layer.getLayerSource().getFeaturesInExtent(extent);
      }
      if (this.hasActiveFilter()) {
        const filter = new Filter();
        console.log(this.layer.getTableFilterValue());
        filter.fromCQL(this.layer.getTableFilterValue());
        this.allFeatures = this.allFeatures.filter((x:any) => filter.evaluate(x));
      }
      this.featureSource.addFeatures(this.allFeatures);
      this.rows = this.allFeatures.length;
      this.features = this.allFeatures.slice(0, this.perPage);
      this.refreshInfos();
    }
  }

  addTableFilter(filter:any) {
    console.log(filter);
    if (this.layer.tableFilter && this.layer.tableFilter.length > 0) {
      this.layer.tableFilter = `(${this.layer.tableFilter} AND ${filter})`;
    } else {
      this.layer.tableFilter = filter;
    }

    this.showAddFilterPanel = false;
    this.refresh();
  }

  onClick(feature: Feature<any>) {
    if (!this.isSelected(feature)) {
      this.onFeatureSelected([feature], false);
    } else {
      this.onFeatureUnSelected([feature], false);
    }
  }

  onFeatureUnSelected(features:any, scrollIntoView:boolean) {
    features.forEach((feature:Feature<any>) => {
      this.selectedFeatures
        .splice(this.selectedFeatures.indexOf(feature), 1);
      feature.setStyle(undefined);
    });
  }

  onFeatureSelected(features:any, scrollIntoView:boolean) {
    if (this.multipleSelection === false) {
      this.selectedFeatures.forEach((feature:Feature<any>) => {
        feature.setStyle(undefined);
      });
      this.selectedFeatures = [];
    }

    features.forEach((feature:Feature<any>) => {
      this.selectedFeatures.push(feature);
    });
    this.selectedFeatures.forEach((feature:Feature<any>) => {
      console.log(feature.getStyle());
      feature.setStyle(this.selectStyle);
      console.log(feature.getStyle());
    });

    // Si l'objet selectionné n'est pas dans la page courante, on change de page
    if (this.features.indexOf(this.selectedFeatures[0]) < 0) {
      const fIndex = this.getAllFeatures().indexOf(this.selectedFeatures[0]);
      console.log(fIndex);
      const pageIndex = Math.floor(fIndex / this.perPage);
      console.log(Math.floor(fIndex / this.perPage));
      this.currentPage = pageIndex;
      this.pageChange(pageIndex + 1);
    }
    // Ensuite on met en évidence l'objet dans le tableau
    const self = this;
    if (scrollIntoView) {
      setTimeout(() => {
        const el = self.$el.getElementsByClassName('selected')[0];
        if (el) {
          el.scrollIntoView(false);
        }
      }, 500);
    }
  }

  getAllFeatures() {
    let featureList = this.allFeatures;
    if (this.layer.isWFS()) {
      featureList = this.layer.getLayerSource().getFeatures();
    }
    if (this.sortParameters !== undefined) {
      featureList.sort(this.dynamicSort(this.sortParameters.attribute.name));
    }
    return featureList;
  }

  addGeometricFilter(filter:Geometry) {
    // eslint-disable-next-line no-underscore-dangle
    let _dataProjection = 'EPSG:2154';
    if (this.layer.dataProjection && this.layer.dataProjection.length > 0) {
      _dataProjection = this.layer.dataProjection;
    }
    console.log(filter);
    const reproj = filter.clone().transform('EPSG:3857', _dataProjection);

    let fProjection = _dataProjection;
    if (fProjection === 'EPSG:4326') {
      fProjection = 'WGS84'; // pour faire une inversion lat/lon => lon/lat
    }
    const geom = new WKT().writeGeometry(reproj,
      {
        featureProjection: fProjection,
        dataProjection: _dataProjection,
        decimals: 3,
      });
    console.log(filter);
    const geomAttribute = this.layer.getGeomAttributeName();
    const geomFilter = `INTERSECTS(${geomAttribute} , ${geom})`;
    this.layer.tableGeometricFilter = geomFilter;
    this.showAddFilterPanel = false;
  }

  download(format:string, extension:string) {
    /*
    const featobj = (new GeoJSON()).writeFeaturesObject(this.allFeatures, { decimals: 2 });
    featobj.crs = { type: 'name', properties: { name: 'urn:ogc:def:crs:EPSG::3857' } };
    const featstring = JSON.stringify(featobj);
    const blob = new Blob([featstring],
      { type: 'text/plain;charset=utf-8' });
    FileSaver.saveAs(blob, `${this.layer.title}_export.geojson`);
    */

    FileSaver.saveAs(this.currentUrl.replace('outputFormat=json', `outputFormat=${format}`), `${this.layer.title}_export.${extension}`);
  }

  addPolygoneFilter() {
    EventBus.$emit(EVENTS.OPEN_LEFT_SIDE_MENU, '');
    const message = 'Dessinez un polygone sur la carte pour définir un filtre spatial (double clic pour terminer la géométrie).<br> <b>Astuces :</b> <ul><li>Maintenez la touche shift enfoncée pour faire un dessin à main levée</li><li>Une fois le polygone dessiné il reste affiché et modifiable en cliquant sur son coutour</li><ul>';
    // EventBus.$emit(EVENTS.INFO, message);
    EventBus.$emit(EVENTS.WARNING, new AlertMessage({ label: message, type: 'success', autoHide: false }));

    this.addInteractionLayer();
    this.addInteraction('Polygon');
  }

  hasActiveFilter():boolean {
    return (this.layer.filter !== undefined && this.layer.filter.length > 0)
      || (this.layer.tableFilter !== undefined && this.layer.tableFilter.length > 0)
      || (this.layer.geometricFilter !== undefined && this.layer.geometricFilter.length > 0)
      || (this.layer.tableGeometricFilter !== undefined
        && this.layer.tableGeometricFilter.length > 0);
  }

  addPointFilter() {
    EventBus.$emit(EVENTS.OPEN_LEFT_SIDE_MENU, '');
    EventBus.$emit(EVENTS.INFO, 'Placez un point sur la carte pour définir un filtre spatial');
    this.addInteractionLayer();
    this.addInteraction('Point');
  }

  private removeInteraction() {
    // EventBus.$emit(EVENTS.ENABLE_SELECTION);
    /*
    if (this.vector != null) {
      this.getMapService().map.removeLayer(this.vector);
    }
    */
    // this.getMapService().map.un('pointermove', this.pointerMoveListener);

    this.getOpenLayersMapService().map.removeInteraction(this.draw);
  }

  private addInteractionLayer() {
    EventBus.$emit(EVENTS.DISABLE_SELECTION);
    this.geomFilterSource = new VectorSource();
    if (this.vector != null) {
      this.getOpenLayersMapService().map.removeLayer(this.vector);
    }
    this.vector = new VectorLayer({
      source: this.geomFilterSource,
      zIndex: 1000,
      style: new Style({
        stroke: new Stroke({
          color: 'rgba(129, 219, 153,1)',
          width: 4,
        }),
      }),
    });

    this.getOpenLayersMapService().map.addLayer(this.vector);
  }

  private addInteraction(type:Type) {
    this.draw = new Draw({
      source: this.geomFilterSource,
      type,
      style: new Style({
        fill: new Fill({
          color: 'rgba(230, 230, 230, 0.2)',
        }),
        stroke: new Stroke({
          color: 'rgba(129, 219, 153,0.5)',
          width: 2,
        }),
        image: new CircleStyle({
          radius: 5,
          stroke: new Stroke({
            color: 'rgba(95, 122, 103,0.5)',
          }),
          fill: new Fill({
            color: 'rgba(230, 230, 230, 0.2)',
          }),
        }),
      }),
    });

    this.getOpenLayersMapService().map.addInteraction(this.draw);

    this.selectForUpdate = new Select({
      // style: this.drawStyle
      layers: [this.vector],
    });
    this.modify = new Modify({
      // style: this.drawStyle,
      features: this.selectForUpdate.getFeatures(),
    });
    this.getOpenLayersMapService().map.addInteraction(this.selectForUpdate);
    this.getOpenLayersMapService().map.addInteraction(this.modify);

    const self = this;
    console.log('end');
    this.draw.on('drawend', (event:any) => {
      EventBus.$emit(EVENTS.INFO, '');
      console.log(event.feature.getGeometry());
      self.addGeometricFilter(event.feature.getGeometry());
      self.removeInteraction();
      this.refresh();
    });

    this.modify.on('modifyend', (evt: any) => {
      const feature = evt.features.getArray()[0];
      self.addGeometricFilter(feature.getGeometry());
      this.refresh();
    });
  }

  applyFilters() {
    this.refresh();
  }

  refreshInfos() {
    this.maxFeatureLoaded = this.rows === this.layer.maxFeatures;
    if (this.maxFeatureLoaded) {
      this.dismissCountDown = 10;
      const message = `<i>Nombre maximum d'objets atteint pour cette couche <b>(${this.layer.maxFeatures} sur ${this.nbFeatureServerSide})</b>,
        Vous pouvez rajouter un filtre ou augmenter la limite dans la configuration de la couche</i>`;
      EventBus.$emit(EVENTS.WARNING, new AlertMessage({ label: message, autoHide: true }));
    }
    if (this.expanded) {
      this.title = this.layer.title;
      if (this.nbFeatureServerSide >= 0 && this.rows !== this.nbFeatureServerSide) {
        this.pagingInfos = `Carte: ${this.rows} résultats sur ${this.nbFeatureServerSide}`;
      } else {
        this.pagingInfos = `Carte: ${this.rows} résultats`;
      }
    }
  }

  expand() {
    // this.expanded = !this.expanded;
    this.$emit('close');
    this.contextService.tablelayer = this.layer;
  }

  close() {
    // this.expanded = !this.expanded;
    this.contextService.tablelayer = null;
  }

  beforeDestroy() {
    EventBus.$emit(EVENTS.ENABLE_SELECTION);
    this.layer.tableFilter = '';
    this.layer.tableGeometricFilter = '';
    if (this.featureSource) {
      this.featureSource.clear();
      this.getOpenLayersMapService().map.removeLayer(this.olLayer);
    }
    if (this.vector != null) {
      this.getOpenLayersMapService().map.removeLayer(this.vector);
    }

    setTimeout(() => {
      this.getOpenLayersMapService().map.updateSize();
    }, 1000);
  }

  addVectorLayer() {
    if (!this.featureSource) {
      this.featureSource = new VectorSource();

      this.olLayer = new VectorLayer({
        source: this.featureSource,
        style: this.defaultStyle,
      });
      this.olLayer.setZIndex(80);
      this.getOpenLayersMapService().map.addLayer(this.olLayer);
      this.select = new Select({
        style: this.selectStyle,
      });
      this.getOpenLayersMapService().map.addInteraction(this.select);
      const self = this;
      this.select.on('select', (e:any) => {
        self.onFeatureSelected(e.target.getFeatures(), true);
      });
    } else {
      this.featureSource.clear();
    }
  }

  getLabel(k:any):string {
    if (k.label) return k.label;
    return k.name;
  }

  dynamicSort(property:string) {
    let sortOrder = 1;
    if (this.sortParameters.ascending === false) {
      sortOrder = -1;
    }
    return function (a:any, b:any) {
      let aProp = a.getProperties()[property];
      if (aProp == null || aProp === undefined) { aProp = ''; }
      let bProp = b.getProperties()[property];
      if (bProp == null || bProp === undefined) { bProp = ''; }
      // eslint-disable-next-line no-nested-ternary
      const result = (aProp < bProp) ? -1
        : (aProp > bProp) ? 1 : 0;
      return result * sortOrder;
    };
  }

  onSortChange(event:any) {
    this.sortParameters = event;
    console.log(this.sortParameters);
    this.pageChange(this.currentPage);
  }

  pageChange(event:number) {
    console.log(event);
    const page = event - 1;
    const featureSource = this.getAllFeatures();
    this.features = featureSource
      .slice(page * this.perPage, page * this.perPage + this.perPage);
  }

  isSelected(feature: any):boolean {
    return this.selectedFeatures.indexOf(feature) >= 0;
  }
}
</script>

<style scoped lang="less">
@import "../../styles/variables.less";

@media screen and (max-height: 700px) {
  .filter_type{
    font-size: 0.8rem;
  }
  .filter_header{
    display: none;
  }
}

.map-paging-infos{
  font-style: italic;
  font-size: 80%;
}
.featurelist_panel_header{
  height:30px;
  box-shadow:0 1px 3px rgba(0, 0, 0, 0.12), 0 -1px 5px rgba(0, 0, 0, 0.24);
}

.filter_panel{
  box-shadow:0 1px 3px rgba(0, 0, 0, 0.12), 0 -1px 5px rgba(0, 0, 0, 0.24);
  margin:3px;
  padding : 5px;
  border-radius: 5px;
}

.dd_btn{
  border-radius: 5px;
}

.featurelist_panel_body{
  flex: 1 1 200px;
  overflow: auto;
}
h4{
  font-size: 1.2rem;
  background-color: #f2f2f2;
  border-bottom: 0px;
  max-width: 100%;
  display: inline-block;
  white-space: nowrap;
  text-overflow: ellipsis;
  overflow: hidden;
}

.expanded{
  box-shadow:0 1px 3px rgba(0, 0, 0, 0.12), 0 -1px 5px rgba(0, 0, 0, 0.24);
  height:30vh;
  min-height:180px;
}

.expanded tbody{
  overflow:auto;
  /* max-height:300px;*/
}

.text-light{
  color: #363636 !important;
}

.close-btn{
  cursor: pointer;
}
/*
button.header_button {
  background-color: white;
  color: @second;
  border: 0px;
  box-shadow:0 1px 3px rgba(0, 0, 0, 0.12), 0 -1px 5px rgba(0, 0, 0, 0.24);
}

.dropdown-toggle {
  background-color: white;
  color: @second;
  border: 0px;
  box-shadow:0 1px 3px rgba(0, 0, 0, 0.12), 0 -1px 5px rgba(0, 0, 0, 0.24);
}
*/
.btn_text{
  visibility: hidden;
  width: 0px;
  display:inline-block;
  margin-right: 2px;
}

.header_button:hover > .btn_text
, .show > .header_button > .btn_text
, .header_button.active > .btn_text {
  padding-right:2px;
  padding-left:2px;
  color: #363636;
  width: calc(100% - 20px);
  height: 20px;
  animation: fade_in_show 0.5s;
  visibility: visible;
}

@keyframes fade_in_show {
     0% {
          opacity: 0;
          width: 0px;
          visibility: hidden;
     }

     100% {
          opacity: 1;
          width: calc(100% - 20px);
          visibility: visible;
     }
}

/*

.header_button {
  margin-top:2px;
  background-color: #fff !important;
  border-color: #dbdbdb;
  border-width: 1px;
  color: #363636;
  cursor: pointer;
  justify-content: center;
  text-align: center;
  white-space: nowrap;
  padding:1px 3px 1px 3px;
}

.header_button:hover, .btn-info.active {
  border-color: black;
  background-color: #fff !important;
  border-color: #dbdbdb;
  border-width: 1px;
  color: #363636 !important;

}
/*
.btn-outline-light{
  border:0px;
}
.btn-outline-light:hover .text-light {
    color: @second !important;
}
.btn-outline-light.active .text-light {
    color: @second !important;
}
*/
</style>
